import React from 'react';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var createStatefulContext = function createStatefulContext() {
  var Context = React.createContext({
    setContextState: function setContextState() {},
    startObservingState: function startObservingState() {},
    stopObservingState: function stopObservingState() {}
  });

  var Provider = function (_React$Component) {
    inherits(Provider, _React$Component);

    function Provider(props) {
      classCallCheck(this, Provider);

      var _this = possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).call(this, props));

      var initialState = typeof props.getInitialState === 'function' ? props.getInitialState.call(_this) : props.getInitialState;

      _this.observables = [];
      _this.state = _extends({}, initialState, {
        setContextState: function setContextState() {
          return _this.setContextState.apply(_this, arguments);
        },
        startObservingState: function startObservingState() {
          return _this.startObservingState.apply(_this, arguments);
        },
        stopObservingState: function stopObservingState() {
          return _this.stopObservingState.apply(_this, arguments);
        }
      });
      return _this;
    }

    createClass(Provider, [{
      key: 'setContextState',
      value: function setContextState(newState) {
        this.setState(newState);
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate(_, prevState) {
        var _this2 = this;

        Object.keys(this.state).filter(function (key) {
          return _this2.state !== prevState[key];
        }).forEach(function (key) {
          return _this2.runObserver(key);
        });
      }
    }, {
      key: 'runObserver',
      value: function runObserver(name) {
        var _this3 = this;

        this.observables.filter(function (def) {
          return def.name === name;
        }).forEach(function (def) {
          return def.fn(_this3.state, _this3);
        });
      }
    }, {
      key: 'startObservingState',
      value: function startObservingState(name, fn) {
        this.observables.push({ name: name, fn: fn });
      }
    }, {
      key: 'stopObservingState',
      value: function stopObservingState(name, fn) {
        this.observables.filter(function (def) {
          return def.name === name && def.fn === fn;
        });
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(
          Context.Provider,
          { value: this.state },
          this.props.children
        );
      }
    }]);
    return Provider;
  }(React.Component);

  return {
    Context: Context,
    Provider: Provider,
    Consumer: Context.Consumer
  };
};

var defaultContext = createStatefulContext();
var Context = defaultContext.Context,
    Consumer = defaultContext.Consumer,
    Provider = defaultContext.Provider;

export default defaultContext;
export { createStatefulContext, Context, Consumer, Provider };
//# sourceMappingURL=index.es.js.map
